; 11/28/2007 Removed concat_dir.

PRO read_errors_cdf
COMMON read_cdf_com

; open file
errors_st = 'Errors_' + in_file
if n_elements(out_directory) eq 1 then out_errors_filename = out_directory+'/'+errors_st ELSE $
  out_errors_filename = errors_st
openw, out_errors_lun, out_errors_filename, /get_lun
header = 'Errors Data from file: '+in_file+' Instrument: '+instrument_id+$
         ' CdfReader Version: '+string(version)
printf, out_errors_lun, header

header = 'One minute products'
printf, out_errors_lun, header
header = 'Day'+tab+'Time'+tab+'Cycle'
printf, out_errors_lun, header
IF epoch1info.maxrec GE 0 THEN BEGIN 
    FOR ii = 0, epoch1info.maxrec DO BEGIN 
        IF read_whole_file EQ 1 OR (epoch1[ii] GE start_time AND epoch1[ii] LE stop_time) THEN BEGIN 
            IF error1[ii] EQ 1 THEN BEGIN 
                temp_string = strmid(epoch1[ii], 0, 10)+tab+strmid(epoch1[ii], 11, 12)+tab+string(cycle1[ii])
                printf, out_errors_lun, temp_string
            ENDIF 
        ENDIF
    ENDFOR 
ENDIF 

printf, out_errors_lun, ' '
header = 'Heavy Ion products'
printf, out_errors_lun, header
header = 'Day'+tab+'Time'+tab+'Cycle'
printf, out_errors_lun, header
IF epoch5info_heavy.maxrec GE 0 THEN BEGIN 
    FOR ii = 0, epoch5info_heavy.maxrec DO BEGIN 
        IF read_whole_file EQ 1 OR (epoch5_heavy[ii] GE start_time AND epoch5_heavy[ii] LE stop_time) THEN BEGIN 
            IF error5_heavy[ii] EQ 1 THEN BEGIN 
                temp_string = strmid(epoch5_heavy[ii], 0, 10)+tab+strmid(epoch5_heavy[ii], 11, 12)+tab+string(cycle5_heavy[ii])
                printf, out_errors_lun, temp_string
            ENDIF 
        ENDIF
    ENDFOR 
ENDIF 

printf, out_errors_lun, ' '
header = 'Five minute monitor rates'
printf, out_errors_lun, header
header = 'Day'+tab+'Time'+tab+'Cycle'
printf, out_errors_lun, header
IF epoch5info_mon.maxrec GE 0 THEN BEGIN 
    FOR ii = 0, epoch5info_mon.maxrec DO BEGIN 
        IF read_whole_file EQ 1 OR (epoch5_mon[ii] GE start_time AND epoch5_mon[ii] LE stop_time) THEN BEGIN 
            IF error5_mon[ii] EQ 1 THEN BEGIN 
                temp_string = strmid(epoch5_mon[ii], 0, 10)+tab+strmid(epoch5_mon[ii], 11, 12)+tab+string(cycle5_mon[ii])
                printf, out_errors_lun, temp_string
            ENDIF 
        ENDIF
    ENDFOR 
ENDIF 

; close file
close, out_errors_lun
free_lun, out_errors_lun


END 
